using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using System.Threading;

namespace CCM.Seat
{
	/// <summary>
	/// Zusammendfassende Beschreibung fr ButtonGrafic.
	/// </summary>
	public class Courtesy : Comp
	{
		// Coops
		public VFS MotorLA = new VFS(3);
		public VFR KL = new VFR(5);
		public VFR Door = new VFR(2);

		bool on = false;
		bool activeRestore = false;
		float orgPos = 0.0F;
		bool orgPosValid = false;

		bool meanwhile = false;

		float courtesyPoint = 60.0F;
		/*
		public float CourtesyPoint 
		{
			get { return courtesyPoint; }
			set 
			{
				if (value <   0.0F) return;
				if (value > 100.0F) return;
				courtesyPoint = value;
			}
		}
		*/

		byte count = 0;

		protected override void Run() 
		{
			// 1. Determine flanks
			bool keyOut = KL.stateChanges(1,0); 
			bool keyIn  = KL.stateChanges(0,1); 
			bool turnedToK15R = KL.stateChanges(1,2) || KL.stateChanges(3,2);

			bool doorOpened = Door.stateChanges(0,1);
			bool doorClosed = Door.stateChanges(1,0);

			if (doorOpened || turnedToK15R) count = 0;

			if (MotorLA.StateFb != 0) meanwhile = true;

			// 2. Determine action
			bool startGettingIn = 
				doorOpened && 
				(KL.State == 0) && 
				(MotorLA.ContFb <= courtesyPoint);

			bool startGettingOut  = 
				(keyOut || (((KL.State == 1) || (KL.State == 2)) && doorOpened)) && 
				(MotorLA.ContFb <= courtesyPoint);

			bool stopGettingInOut = 
				on && (
					!MotorLA.checkStateFeedback(1000) || 
					MotorLA.Lose || 
					(MotorLA.ContFb > courtesyPoint) || 
					(KL.State == 3) || 
					doorClosed);
			
			bool startRestore = 
				!meanwhile &&
				(count<3) && 
				(MotorLA.ContFb>orgPos) && 
				orgPosValid && 
				(keyIn || (((KL.State == 1) || (KL.State == 2)) && doorClosed));

			bool stopRestore = 
				activeRestore && 
				!MotorLA.checkStateFeedback(1000) || 
					MotorLA.Lose || 
					((MotorLA.ContFb <= orgPos) && (orgPosValid)) ||
					(KL.State == 3);

			// Start GettingInOut
			if ((startGettingIn || startGettingOut) && !on)
			{
				//Console.WriteLine("Start GettingInOut");
				on = true; 
				
				MotorLA.acquireCooperation();
				orgPos = MotorLA.ContFb; orgPosValid = true;
				//Console.WriteLine("Save org pos to "+orgPos.ToString());
				MotorLA.Cont = courtesyPoint;
				MotorLA.State = 2;
			}	
			
			// Stop GettingInOut
			if (on && stopGettingInOut)
			{
				//Console.WriteLine("Stop GettingInOut");
				on = false; meanwhile = false;
				if (!MotorLA.Lose)
				{
					MotorLA.State = 0;
					MotorLA.releaseCooperation();
					meanwhile = false;
				}
			}

			// Start Restore
			if (!activeRestore && startRestore) 
			{
				count++;
				//Console.WriteLine("Start Restore to "+orgPos.ToString());
				MotorLA.acquireCooperation(); 
				MotorLA.State = 1;
				MotorLA.Cont = orgPos;
				activeRestore = true;
			}

			if (activeRestore && stopRestore)
			{
				//Console.WriteLine("Stop Restore");
				activeRestore = false;
				if (!MotorLA.Lose)
				{
					MotorLA.State = 0;
					MotorLA.releaseCooperation();
				}
			}
		}
	}
}
